`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/05/12 00:33:50
// Design Name: 
// Module Name: value_temp_reg
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`include "global.vh"

module value_temp_reg(
    digit_0,
    digit_1,
    digit_2,
    digit_3,
    state_sel,
    valid,
    decoded_input,
    rst
);
    output reg [3:0] digit_0, digit_1, digit_2, digit_3;
    
    input valid;
    input rst;
    input [2:0] state_sel;
    input [3:0] decoded_input;

    reg [3:0] digit_0_tmp, digit_1_tmp, digit_2_tmp, digit_3_tmp;

    always @*
        if (state_sel == `DIGIT_3_STATE) 
            begin
                digit_3_tmp = decoded_input;
                digit_2_tmp = digit_2;
                digit_1_tmp = digit_1; 
                digit_0_tmp = digit_0;
            end
        else if (state_sel == `DIGIT_2_STATE)
            if (decoded_input == `key_add_pos || decoded_input == `key_subtract_pos || decoded_input == `key_multiply_pos || decoded_input == `key_enter_pos)
                begin
                digit_3_tmp = digit_3;
                digit_2_tmp = digit_2;
                digit_1_tmp = digit_1; 
                digit_0_tmp = digit_0;
                end
            else
                begin
                digit_3_tmp = digit_3;
                digit_2_tmp = decoded_input;
                digit_1_tmp = digit_1; 
                digit_0_tmp = digit_0;
                end
        else if (state_sel == `DIGIT_1_STATE)
            begin
                digit_3_tmp = digit_3;
                digit_2_tmp = digit_2;
                digit_1_tmp = decoded_input; 
                digit_0_tmp = digit_0;
            end
        else if (state_sel == `DIGIT_0_STATE)
           if (decoded_input == `key_add_pos || decoded_input == `key_subtract_pos || decoded_input == `key_multiply_pos || decoded_input == `key_enter_pos)
                begin
                digit_3_tmp = digit_3;
                digit_2_tmp = digit_2;
                digit_1_tmp = digit_1; 
                digit_0_tmp = digit_0;
                end
            else
                begin
                digit_3_tmp = digit_3;
                digit_2_tmp = digit_2;
                digit_1_tmp = digit_1; 
                digit_0_tmp = decoded_input;
                end
        else 
            begin
                digit_3_tmp = digit_3;
                digit_2_tmp = digit_2;
                digit_1_tmp = digit_1; 
                digit_0_tmp = digit_0;
            end
    
    always @(posedge valid or posedge rst)
        if (rst)
            begin
                digit_0 <= 4'd0;
                digit_1 <= 4'd0;
                digit_2 <= 4'd0;
                digit_3 <= 4'd0;
            end
        else
            begin
                digit_0 <= digit_0_tmp;
                digit_1 <= digit_1_tmp;
                digit_2 <= digit_2_tmp;
                digit_3 <= digit_3_tmp;
            end    
endmodule
